/*==============================================================================


       eg_9 - Menu Example

              Copyright  2001 Pankhurst Algorithmics - All Rights Reserved
              visit www.ebmDevMag.com for permissions/restrictions on use


==============================================================================*/
#include "gui.h"
#include "ebm_object.h"

extern "C"
{
#include "ereader_hostio.h"
}
#include "eg_9_form.h"
/*==============================================================================

       main window - just button checker

==============================================================================*/
void CWindow1::Initialize(void)
{
  // set up menu #1 - with shortcuts
  m_menu1=new CMenu(ID_MENU1,0,32767,0,this);
	m_menu1->SetNumRows(4);
  int row=-1;
	m_menu1->SetRow( ++row,IDM_OPTION1,"OPTION1",'v' );
	m_menu1->SetRow( ++row,IDM_OPTION2,"OPTION2",'s' );
	m_menu1->SetSeparatorRow(++row);
	m_menu1->SetRow( ++row,IDM_OPTION3,"OPTION3",'c' );
  // set up menu #2 - without shortcuts
	m_menu2=new CMenu(ID_MENU2,0,32767,0,this);
	m_menu2->SetNumRows(5);
  row=-1;
	m_menu2->SetRow( ++row,IDM_OPTION4,"OPTION4" );
	m_menu2->SetSeparatorRow(++row);
	m_menu2->SetRow( ++row,IDM_OPTION5,"OPTION5" );
	m_menu2->SetSeparatorRow(++row);
	m_menu2->SetRow( ++row,IDM_OPTION6,"OPTION6" );
  // set up menu #3
	m_menu3=new CMenu(ID_MENU3,0,32767,0,this);
	m_menu3->SetNumRows(5);
  row=-1;
	m_menu3->SetRow( ++row,IDM_OPTION7,"OPTION7");
	m_menu3->SetSeparatorRow(++row);   
	m_menu3->SetRow( ++row,IDM_OPTION8,"OPTION8");
	m_menu3->SetSeparatorRow(++row);
	m_menu3->SetRow( ++row,IDM_OPTION9,"OPTION9");
  //
  m_menuBar=new CMenuBar(ID_MENUBAR,23,this);
  m_menuBar->AddButton(new CPushButton( ID_MENU1_BUTTON,0,0,"Opt.1-3"),m_menu1 );
  m_menuBar->AddButton(new CPushButton( ID_MENU2_BUTTON,0,0,"Opt.4-6"),m_menu2 );
  m_menuBar->AddButton(new CPushButton( ID_MENU3_BUTTON,0,0,"Opt.7-9"),m_menu3 );
}
//------------------------------------------------------------------------------
CWindow1::~CWindow1(void)
{
  delete m_menuBar; // cleanup
}
//------------------------------------------------------------------------------
S32 CWindow1::MsgHandler( MSG_TYPE type, CViewable *from, S32 data )
{
  switch (type)
  {
    case MSG_KEY: // process request to show menu
		  if (data == K_MENU)
        m_menuBar->Show();
      return 1;
    case MSG_MENU_SELECT: // handle menu selection
    {
      int value=0;
      switch ((U16)data)
      {
        case IDM_OPTION1:
          value=1;
          break;
        case IDM_OPTION2:
          value=2;
          break;
        case IDM_OPTION3:
          value=3;
          break;
        case IDM_OPTION4:
          value=4;
          break;
        case IDM_OPTION5:
          value=5;
          break;
        case IDM_OPTION6:
          value=6;
          break;
        case IDM_OPTION7:
          value=7;
          break;
        case IDM_OPTION8:
          value=8;
          break;
        case IDM_OPTION9:
          value=9;
          break;
      }
      char buff[99]="";
      sprintf(buff,"Selected Menu Option 'IDM_OPTION%d",value);
      GUI_Alert(ALERT_WARNING,buff);
    }
      return 1;
    default:
      {;}
  }
  return CWindow::MsgHandler(type, from, data);
}
/*==============================================================================


==============================================================================*/
static CWindow1 *f_mainWindow;

//------------------------------------------------------------------------------
S32 GUI_main( MSG_TYPE type, CViewable *object, S32 data )
{
  switch (type)
  {
    case MSG_APP_START:
      if (OS_is_present && hostIO_am_I_the_current_task())
        HOSTIO_INLINE_BREAKPOINT();
      f_mainWindow=new CWindow1();
      f_mainWindow->Initialize();
      return 1;
    case MSG_APP_STOP: // prog exit & cleanup
      delete f_mainWindow;
      return 1;
    default:
      break;
  }
  return 0;
};
//------------------------------------------------------------------------------


